TelepathyQt4: ChannelInterfaceTubeInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

# ChannelInterfaceTubeInterface Class Reference
[Channel proxies]

`#include <TelepathyQt4/Channel>`

Inherits Tp::AbstractInterface.

List of all members.

## Signals

- void TubeChannelStateChanged (uint state)

## Public Member Functions

- ChannelInterfaceTubeInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelInterfaceTubeInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ChannelInterfaceTubeInterface (Tp::DBusProxy *proxy)
- ChannelInterfaceTubeInterface (const Tp::Client::ChannelInterface &mainInterface)
- ChannelInterfaceTubeInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
- QVariantMap Parameters () const TELEPATHY_GNUC_DEPRECATED
- uint State () const TELEPATHY_GNUC_DEPRECATED

## Static Public Member Functions

- static const char * staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Properties

- QVariantMap Parameters
- uint State

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Interface.Tube."

## Constructor & Destructor Documentation

ChannelInterfaceTubeInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a ChannelInterfaceTubeInterface associated with the given object on the session bus.

Parameters:

  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

ChannelInterfaceTubeInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a ChannelInterfaceTubeInterface associated with the given object on the given bus.

Parameters:

  | connection | The bus via which the object can be reached.
  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

ChannelInterfaceTubeInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelInterfaceTubeInterface associated with the same object as the given proxy.

Parameters:

  | proxy | The proxy to use. It will also be the QObject::parent() for this object.

ChannelInterfaceTubeInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) | `[explicit]`

Creates a ChannelInterfaceTubeInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  | mainInterface | The proxy to use.

ChannelInterfaceTubeInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent |
| ) |  |  |

Creates a ChannelInterfaceTubeInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  | mainInterface | The proxy to use.
  | parent | Passed to the parent class constructor.

## Member Function Documentation

static const char* staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Interface.Tube", which this class represents.

Returns:
  The D-Bus interface name.

QVariantMap Parameters | ( |  | ) | const`[inline]`

Getter for the remote object property "Parameters".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint State | ( |  | ) | const`[inline]`

Getter for the remote object property "State".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

void TubeChannelStateChanged | ( | uint | state | ) | `[signal]`

Represents the signal "TubeChannelStateChanged" on the remote object.

Emitted when the state of the tube channel changes. Valid state transitions are documented with Tube_Channel_State.

Parameters:

  | state | The new state of the tube.

virtual void invalidate | ( | Tp::DBusProxy * | ,
|  | const QString & | ,
|  | const QString & |  |
| ) |  |  | `[protected, virtual]`

## Property Documentation

QVariantMap Parameters`[read]`

Represents property "Parameters" on the remote object.

Each tube has a dictionary of arbitrary parameters. Parameters are commonly used to bootstrap legacy protocols where you can't negotiate parameters in-band. The allowable keys, types and values are defined by the service, but connection managers must support the value being a string (D-Bus type `'s'`), array of bytes (D-Bus type `'ay'`), unsigned integer (D-Bus type `'u'`), integer (D-Bus type `'i'`) and boolean (D-Bus type `'b'`).

When the tube is offered, the parameters are transmitted with the offer and appear as a property of the incoming tube for other participants.

For example, a stream tube for <tp:dbus-ref namespace="org.freedesktop.Telepathy.Channel.Type.StreamTube">Service</tp:dbus-ref> `"smb"` (<cite>Server Message Block over TCP/IP</cite>) might use the following properties, as defined in DNS SRV (RFC 2782) Service Types:

     { 'u': 'some-username',
       'p': 'top-secret-password',
       'path': '/etc/passwd',
     }

When requesting a tube with <tp:dbus-ref namespace="org.freedesktop.Telepathy.Connection.Interface.Requests">CreateChannel</tp:dbus-ref>, this property MUST NOT be included in the request; instead, it is set when <tp:dbus-ref namespace="org.freedesktop.Telepathy.Channel.Type">StreamTube.Offer</tp:dbus-ref> or <tp:dbus-ref namespace="org.freedesktop.Telepathy.Channel.Type">DBusTube.Offer</tp:dbus-ref> (as appropriate) is called. Its value is undefined until the tube is offered; once set, its value MUST NOT change.

When receiving an incoming tube, this property is immutable and so advertised in the <tp:dbus-ref namespace="org.freedesktop.Telepathy.Connection.Interface.Requests">NewChannels</tp:dbus-ref> signal.

uint State`[read]`

Represents property "State" on the remote object.

State of the tube in this channel.

When requesting a tube with <tp:dbus-ref namespace="org.freedesktop.Telepathy.Connection.Interface.Requests">CreateChannel</tp:dbus-ref>, this property MUST NOT be included in the request.